// pacchetti da importare per la gestione di applet, grafica ed eventi.

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class Life extends Applet
{
    
    /** definire i seguenti attributi:
     *  - variabile intera lato: dimensione in pixel del lato di una cella della griglia 
     *  - variabile intera n: rappresenta il numero di righe e di colonne della griglia (i.e. griglia nxn)
     *  - matrice di booleani mat: rappresenta logicamente la griglia nxn del gioco Life
     *      Uso se mat[i][j]==true la cella (i,j) e' viva (attiva)
     *          se mat[i][j]==false la cella (i,j) e' morta (disattiva)
     */
    
   
    
    
    
    public void init()
    {
       /** il metodo init viene eseguito automaticamente in fase di inizializzazione dell'applet.
        *  Tale metodo deve:
        *  
        *  - dare un valore all'attributo n (es. n=20, per costruire una griglia di 20x20 celle)
        *  - dare un valore all'atributo lato (es. lato=10, per costruire celle di 10x10 pixel)
        *  - allocare una struttura dati di n*n celle nella matrice mat.
        *  - inizializzare a false tutte le componenti di mat (e.g mat[i][j]= false, per ogni 0<=i,j<n 
        *  - collegare l'applet con l'ascoltatore delle pressioni dei tasti del mouse di nome AscoltatoreClick
        */
       
       
       
    }
    
    public int contaAttive(int i, int j)
    {
      /** il metodo contaAttive(int i, int j)
          deve ritornare un valore intero
          corrispondente al numero di celle attive
          nell'intorno della cella (i,j).
          (Si veda la fig. 1 del documento che descrive il gioco life)
          ATTENZIONE: Tipicamente l'intorno di una cella (i,j) e' costituito da 8 celle.
          Nei casi in cui (i==0 o j==0) il numero di celle dell'intorno diminuisce.
      */
     
      int attive=0;
      
      //implementare...
      
      return attive;  
    }    
    
   
    public void paint(Graphics g){
      
      /** il metodo paint deve disegnare una griglia di n*n celle. Ogni cella e'
          costituita da un quadrato di lato*lato pixel. L'angolo superiore sinistro 
          della griglia deve avere coordinate (0,0).
          Sia C la cella di riga i e colonna j. C deve essere colorata di giallo se mat[i][j] e' true, 
          altrimenti deve essere colorata di blue.
      */
     
     
     
    }   
    
    /**  Classe Ascoltatore per la gestione delle pressioni del mouse */
    public class AscoltatoreClick extends MouseAdapter{
       
        public void  mousePressed(MouseEvent e){
          
          /** mousePressed e' un metodo invocato ogni volta che si preme un qualsiasi tasto del mouse-
           * 
           * Questo metodo deve:
           *  - definire e allocare una matrice ausiliare di booleani di dimensione n*n 
           *  - se si preme il tasto sinistro del mouse all'interno della griglia
           *      - determinare la riga i e la colonna j della cella selezionata 
           *      - colorarla di giallo
           *      - assegnare il valore true all'elemento di riga i e colonna j nella matrice mat
           *    altrimenti
           *      - per ogni riga i della matrice mat
           *      - per ogni colonna j della matrice mat
           *      -   analizzare la cella mat[i][j] ed eseguire 
           *          la regola della vita oppure la regola della sopravvivenza
           *          sulla cella (i,j) a seconda del valore di mat[i][j]. 
           *          (Per magggiori dettagli si veda il documento contenete le specifiche del gioco)
           *          Il valore ottenuto attraverso l'esecuzione della regola opportuna
           *          deve essere assegnato all'elemento di riga i e colonna j della matrice aux
           *          
           *      - al termine dell'analisi copiare l'intera matrice aux nella matrice mat
           *      - richiamare il metodo paint
           */  
                 
        }
    }
    
}

	